"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.CustomParser = exports.parseAsCustom = void 0;
var abstract_1 = __importDefault(require("../class/abstract"));
var action_1 = require("../function/action");
function parseAsCustom(b) {
    return b.predicate(b.value) ? b.value : (0, action_1.determineAction)(b);
}
exports.parseAsCustom = parseAsCustom;
var CustomParser = /** @class */ (function (_super) {
    __extends(CustomParser, _super);
    function CustomParser(value, predicate) {
        var _this = _super.call(this, value) || this;
        _this.predicate = predicate;
        _this.elseGet = function (alternativeValue) {
            return parseAsCustom({
                alternativeValue: alternativeValue,
                value: _this.value,
                ifParsingFailThen: 'get',
                predicate: _this.predicate
            });
        };
        _this.elseLazyGet = function (alternativeValue) {
            return parseAsCustom({
                alternativeValue: alternativeValue,
                value: _this.value,
                ifParsingFailThen: 'lazy-get',
                predicate: _this.predicate
            });
        };
        _this.elseThrow = function (message) {
            return parseAsCustom({
                message: message,
                value: _this.value,
                predicate: _this.predicate,
                ifParsingFailThen: 'throw'
            });
        };
        return _this;
    }
    return CustomParser;
}(abstract_1["default"]));
exports.CustomParser = CustomParser;
//# sourceMappingURL=index.js.map