"use strict";
exports.__esModule = true;
exports.isInRangeOf = exports.inRangeOf = void 0;
var inRangeOf = function (_a) {
    var min = _a.min, max = _a.max;
    if (min > max || max < min) {
        throw new Error("min must be less than max, max must also be greater than min. Min: ".concat(min, ", Max: ").concat(max));
    }
    return {
        min: min,
        max: max
    };
};
exports.inRangeOf = inRangeOf;
var isInRangeOf = function (_a) {
    var min = _a.min, max = _a.max, value = _a.value;
    return value >= min && value <= max;
};
exports.isInRangeOf = isInRangeOf;
//# sourceMappingURL=index.js.map