"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.parseAsNumber = exports.NumberParser = void 0;
var abstract_1 = __importDefault(require("../class/abstract"));
var action_1 = require("../function/action");
var helper_1 = require("../helper");
function parseAsNumber(b) {
    if (typeof b.number !== 'number') {
        return (0, action_1.determineAction)(b);
    }
    var number = b.number;
    if (!b.inRangeOf) {
        return number;
    }
    return (0, helper_1.isInRangeOf)(__assign(__assign({}, (0, helper_1.inRangeOf)(b.inRangeOf)), { value: number }))
        ? number
        : (0, action_1.determineAction)(b);
}
exports.parseAsNumber = parseAsNumber;
var NumberParser = /** @class */ (function (_super) {
    __extends(NumberParser, _super);
    function NumberParser(value) {
        var _this = _super.call(this, value) || this;
        _this.inRangeOf = function (rangeOf) {
            _this.range = (0, helper_1.inRangeOf)(rangeOf);
            return _this;
        };
        _this.elseThrow = function (message) {
            return parseAsNumber({
                message: message,
                number: _this.value,
                inRangeOf: _this.range,
                ifParsingFailThen: 'throw'
            });
        };
        _this.elseGet = function (alternativeValue) {
            return parseAsNumber({
                alternativeValue: alternativeValue,
                number: _this.value,
                inRangeOf: _this.range,
                ifParsingFailThen: 'get'
            });
        };
        _this.elseLazyGet = function (alternativeValue) {
            return parseAsNumber({
                alternativeValue: alternativeValue,
                number: _this.value,
                inRangeOf: _this.range,
                ifParsingFailThen: 'lazy-get'
            });
        };
        return _this;
    }
    return NumberParser;
}(abstract_1["default"]));
exports.NumberParser = NumberParser;
//# sourceMappingURL=number.js.map