import ParserError from '../../error/index.js';
const determineAction = (b) => {
    switch (b.ifParsingFailThen) {
        case 'get':
            return b.alternativeValue;
        case 'lazy-get':
            return b.alternativeValue();
        case 'throw':
            throw ParserError.fromMessage(b.message);
    }
};
export { determineAction };
//# sourceMappingURL=action.js.map