"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.parseAsBoolean = exports.BooleanParser = void 0;
var abstract_1 = __importDefault(require("../class/abstract"));
var action_1 = require("../function/action");
function parseAsBoolean(b) {
    return typeof b.boolean === 'boolean' ? b.boolean : (0, action_1.determineAction)(b);
}
exports.parseAsBoolean = parseAsBoolean;
var BooleanParser = /** @class */ (function (_super) {
    __extends(BooleanParser, _super);
    function BooleanParser(value) {
        var _this = _super.call(this, value) || this;
        _this.elseGet = function (alternativeValue) {
            return parseAsBoolean({
                alternativeValue: alternativeValue,
                boolean: _this.value,
                ifParsingFailThen: 'get'
            });
        };
        _this.elseLazyGet = function (alternativeValue) {
            return parseAsBoolean({
                alternativeValue: alternativeValue,
                boolean: _this.value,
                ifParsingFailThen: 'lazy-get'
            });
        };
        _this.elseThrow = function (message) {
            return parseAsBoolean({
                message: message,
                boolean: _this.value,
                ifParsingFailThen: 'throw'
            });
        };
        return _this;
    }
    return BooleanParser;
}(abstract_1["default"]));
exports.BooleanParser = BooleanParser;
//# sourceMappingURL=boolean.js.map