declare type RangeOf = Readonly<{
    min: number;
    max: number;
}>;
declare const inRangeOf: ({ min, max }: RangeOf) => RangeOf;
declare const isInRangeOf: ({ min, max, value, }: Readonly<{
    min: number;
    max: number;
}> & Readonly<{
    value: number;
}>) => boolean;
export { RangeOf, inRangeOf, isInRangeOf };
